package common.util;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.junit.Test;

public class CsvUtilTest {

	@Test
	public void testReadCsvWithTitle_001() {
		System.out.println("testReadCsvWithTitle_001() start");

		String csvpath = "input/Sample001.csv" ;
		String encode = "UTF-8" ;
		String sepa = "," ;
		boolean dquoteFlg = true ;
		boolean commentFlg = false ;
		boolean readTitle = false ;
		try {
			List<ArrayList<String>> csvList = CsvUtil.readCsvWithTitle(
				csvpath,
				encode,
				sepa,
				true,
				false,
				false);

			ArrayList<Sample001CsvDto> dtoList = new ArrayList<>();

			int lineNo = 0;

			for(ArrayList<String> lineList : csvList){
				lineNo++;
				if (lineList.size() != 2){
					System.out.println("カラム数が不正。"+lineNo+ "行目");
					break;
				}
				Sample001CsvDto dto = new Sample001CsvDto();
				dto.setName(lineList.get(0));
				dto.setCounter(lineList.get(1));

				dtoList.add(dto);
			}
			for(Sample001CsvDto readDto : dtoList){
				System.out.println(readDto.toString());
			}

		} catch (IOException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		}
		System.out.println("testReadCsvWithTitle_001() start");
	}
	@Test
	public void testReadCsvWithTitle_002() {
		System.out.println("testReadCsvWithTitle_002() start");

		String csvpath = "input/Sample002.csv" ;
		String encode = "UTF-8" ;
		String sepa = "," ;
		boolean dquoteFlg = true ;
		boolean commentFlg = false ;
		boolean readTitle = false ;
		try {
			List<ArrayList<String>> csvList = CsvUtil.readCsvWithTitle(
				csvpath,
				encode,
				sepa,
				true,
				false,
				false);

			ArrayList<Sample001CsvDto> dtoList = new ArrayList<>();

			int lineNo = 0;

			for(ArrayList<String> lineList : csvList){
				lineNo++;
				if (lineList.size() != 2){
					System.out.println("カラム数が不正。"+String.format("%03d", lineNo)+ "行目");
					break;
				}
				Sample001CsvDto dto = new Sample001CsvDto();
				dto.setName(lineList.get(0));
				dto.setCounter(lineList.get(1));

				dtoList.add(dto);
			}
			for(Sample001CsvDto readDto : dtoList){
				System.out.println(readDto.toString());
			}

		} catch (IOException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		}
		System.out.println("testReadCsvWithTitle_002() start");
	}
	@Test
	public void testReadCsv() {
		System.out.println("testReadCsv() start");

		String csvpath = "input/Sample001.csv" ;
		String encode = "UTF-8" ;
		String sepa = "," ;
		boolean dquoteFlg = true ;
		boolean commentFlg = false ;

		try {
			List<ArrayList<String>> csvList = CsvUtil.readCsv(
				csvpath,
				encode,
				sepa,
				true,
				false);

			ArrayList<Sample001CsvDto> dtoList = new ArrayList<>();

			int lineNo = 0;

			for(ArrayList<String> lineList : csvList){
				lineNo++;
				if (lineList.size() != 2){
					System.out.println("カラム数が不正。"+lineNo+ "行目");
					break;
				}
				Sample001CsvDto dto = new Sample001CsvDto();
				dto.setName(lineList.get(0));
				dto.setCounter(lineList.get(1));

				dtoList.add(dto);
			}
			for(Sample001CsvDto readDto : dtoList){
				System.out.println(readDto.toString());
			}

		} catch (IOException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		}
		System.out.println("testReadCsv() end");
	}
/*
	@Test
	public void testReadCsvToObj() {
		//fail("まだ実装されていません");

		// csvファイル　CSVデータオブジェクト対応表から
		//
		//



		// @param dtoClassName
		// @param fpath			ファイルパス
		// @param encode		エンコード
		// @param sepa			区切り文字
		// @param dquoteFlg		ダブルクォート有効フラグ true:ダブルクォート有効
		// @param commentFlg	コメント有効フラグ true:コメント行有効

		String dtoname = "common.util.Sample001CsvDto" ;
		String csvpath = "input/Sample001.csv" ;
		String encode = "UTF-8" ;
		String sepa = "," ;
		boolean dquoteFlg = true ;
		boolean commentFlg = false ;

		try {
			List<Object> objList = CsvUtil.readCsvToObj(
					dtoname,
					csvpath,
					encode,
					sepa,
					dquoteFlg,
					commentFlg
					);

			for(Object obj : objList){
				Sample001CsvDto dto = new Sample001CsvDto() ;
				dto = (Sample001CsvDto)obj ;

				System.out.println(dto.toString());
			}
		} catch (ClassNotFoundException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		} catch (InstantiationException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		} catch (SecurityException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		} catch (IOException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		}
	}
*/
}
